/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2012 by Tidalwave s.a.s. (http://tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.integritychecker.archive;

import javax.annotation.Nonnull;
import javax.annotation.concurrent.Immutable;
import java.nio.file.Path;
import org.joda.time.DateTime;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.ToString;
import lombok.experimental.Wither;

/***********************************************************************************************************************
 *
 * A single scanned file.
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@Immutable @Getter @RequiredArgsConstructor @EqualsAndHashCode @ToString 
public class ScannedFile 
  {
    @RequiredArgsConstructor @Immutable @Wither
    public static class Builder
      {
        private final Path file;

        private final String signature;

        private final DateTime scanDateTime;

        public Builder() 
          {
            this(null, null, null);
          }
        
        @Nonnull
        public ScannedFile build()
          {
            final ScannedFile scannedFile = new ScannedFile(file, signature, scanDateTime);
            register(scannedFile);
            return scannedFile;
          }
        
        protected void register (final @Nonnull ScannedFile scannedFile)
          {              
          }
      }
    
    @Nonnull
    private final Path file;
    
    @Nonnull
    private final String signature;
    
    @Nonnull
    private final DateTime scanDateTime;
  }
